﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	
	Type PHAsset_Asset(GUID As String, Width As Float, Height As Float, isVideo As Boolean, Duration As Float, iOS_Asset As Object,CreationDate As Long,ModificationDate As Long,Location As String)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

'<code>Wait For (ph.RequestPermission) Complete (Success As Boolean)</code>
Public Sub RequestPermission As ResumableSub
	
	Dim no As NativeObject
	Dim Status As Int = no.Initialize("PHPhotoLibrary").RunMethod("authorizationStatus", Null).AsNumber
	
	'Possible authorization status values are:
	'   0 = not determined (user permission is required for photo library access but
	'       user has not yet granted or denied such permission)
	'   1 = restricted (app is not authorized to access photo library and user cannot
	'       grant such permission)
	'   2 = denied (user has explicitly denied app access to photo library)
	'   3 = authorized (user has explicitly granted app access to photo library)

	'If authorization status is not determined...
	If Status = 0 Then
		
		'Prompt user for authorization
		Dim No2 As NativeObject = Me
		No2.RunMethod("objc_requestpermission", Null)
		Wait For objc_RequestPermissionDone(Status As Int)
		
		'Set permission result
		Return (Status = 3)	
		'Otherwise, if authorization status is already authorized...
	Else If Status = 3 Then	
		Return True
		'Otherwise, if authorization is denied...
	Else If Status = 2 Then		
		'You can not reverse this via another go at prompting user, you have to
		'resort to directing user to settings for app
		Return False		
		'Otherwise authorization is restricted...
	Else		
		'You are out of luck
		Return False
	End If
	
End Sub

Public Sub GetAllPhotos As List

	Dim no_test As NativeObject = Me
	Dim wrk_no2 As NativeObject = no_test.GetField("fetchPhotos")
	Dim lst_Results As List = wrk_no2

	Dim lst_Assets As List
	lst_Assets.Initialize

	For Each pho As NativeObject In lst_Results
		
		Dim Asset As PHAsset_Asset
		Asset.Initialize
		
		'Flesh out asset as PHAsset
		Asset.GUID = BuildGUID(pho)
		Asset.Width = pho.GetField("pixelWidth").AsNumber
		Asset.Height = pho.GetField("pixelHeight").AsNumber
		
		Asset.CreationDate = pho.GetField("creationDate").GetField("timeIntervalSince1970").AsNumber * 1000
		Asset.ModificationDate = pho.GetField("modificationDate").GetField("timeIntervalSince1970").AsNumber * 1000
		
		'Log(pho.GetField("location"))
		If 2 = pho.GetField("mediaType").AsNumber Then
			Asset.isVideo=True
			Asset.Duration = pho.GetField("duration").AsNumber
		End If
		Asset.iOS_Asset = pho
		
		lst_Assets.Add(Asset)
		
	Next

	Return lst_Assets

End Sub

Public Sub GetPhoto(Asset As PHAsset_Asset) As B4XBitmap

	'Extract bitmap
	Dim wrk_no As NativeObject = Me
	Return wrk_no.RunMethod("objc_getbitmapfromasset:", Array(Asset.GUID))

End Sub

Public Sub GetVideo(Asset As PHAsset_Asset) As B4XBitmap

	'Extract bitmap
	Dim wrk_no As NativeObject = Me
	Return wrk_no.RunMethod("objc_getAVAssetFromAsset:", Array(Asset.GUID))

End Sub

Public Sub GetAllPhotosTodayXYears As List
	
	Dim no_test As NativeObject = Me
	'Dim wrk_no2 As NativeObject = no_test.RunMethodWithBlocks("getAssetsForDay",Array As Object(1))
	
	Dim wrk_no2 As NativeObject = no_test.GetField("fetchAssetsFromLast")
	
	Dim lst_Results As List = wrk_no2

	Dim lst_Assets As List
	lst_Assets.Initialize

	For Each pho As NativeObject In lst_Results
		
		Dim Asset As PHAsset_Asset
		Asset.Initialize
		
		'Flesh out asset as PHAsset
		Asset.GUID = BuildGUID(pho)
		Asset.Width = pho.GetField("pixelWidth").AsNumber
		Asset.Height = pho.GetField("pixelHeight").AsNumber
		
		Asset.CreationDate = pho.GetField("creationDate").GetField("timeIntervalSince1970").AsNumber * 1000
		Asset.ModificationDate = pho.GetField("modificationDate").GetField("timeIntervalSince1970").AsNumber * 1000
		
		'Log(DateUtils.TicksToString(Asset.CreationDate))
		
		'Log(pho.GetField("location"))
		If 2 = pho.GetField("mediaType").AsNumber Then
			Asset.isVideo=True
			Asset.Duration = pho.GetField("duration").AsNumber
		End If
		Asset.iOS_Asset = pho
		
		lst_Assets.Add(Asset)
		
	Next

	Return lst_Assets
	
End Sub

#Region Functions

Private Sub BuildGUID(no_Asset As NativeObject) As String
	
	Dim GUID As String = no_Asset.GetField("localIdentifier").AsString
	Return GUID.SubString2(0, GUID.IndexOf("/"))
	
End Sub

#End Region

#if OBJC

@import Photos;

- (void)objc_RequestPermission
{
    [PHPhotoLibrary requestAuthorizationForAccessLevel:PHAccessLevelReadWrite handler:^(PHAuthorizationStatus status) {
        [self.bi raiseUIEvent:nil event:@"objc_RequestPermissionDone:" params:@[@((int)status)]];
    }];
}



- (UIImage*)objc_getbitmapfromasset:(NSString *)guid
{
    __block UIImage* imgFull;
    CGSize size=CGSizeMake(100, 100);
    PHImageRequestOptions *options = [[PHImageRequestOptions alloc] init];
    options.resizeMode = PHImageRequestOptionsResizeModeExact;
    options.deliveryMode = PHImageRequestOptionsDeliveryModeHighQualityFormat;
    options.networkAccessAllowed = YES;
    options.synchronous = YES;
    
    PHFetchResult *fetchResult = [PHAsset fetchAssetsWithLocalIdentifiers:@[guid] options:nil];
    if (fetchResult.count > 0) {
        // Es wurde mindestens ein Asset mit der angegebenen GUID gefunden
        PHAsset *asset = fetchResult.firstObject;
        [[PHImageManager defaultManager] requestImageForAsset:asset
                                     targetSize:PHImageManagerMaximumSize
                                    contentMode:PHImageContentModeDefault
                                        options:options
                                  resultHandler:^(UIImage *result, NSDictionary *info) 
        {
            imgFull = result;
        }];
    }
    return imgFull;
}


// Videos

- (AVAsset*)objc_getAVAssetFromAsset:(PHAsset*) asset
{
    __block AVAsset *avAsset;
    PHVideoRequestOptions *options = [[PHVideoRequestOptions alloc] init];
    options.version = PHVideoRequestOptionsVersionOriginal;
    options.deliveryMode = PHVideoRequestOptionsDeliveryModeAutomatic;
    options.networkAccessAllowed = YES;
    [[PHImageManager defaultManager] requestAVAssetForVideo:asset options:options resultHandler:^(AVAsset * _Nullable videoAsset, AVAudioMix * _Nullable audioMix, NSDictionary * _Nullable info) {
        avAsset = videoAsset;
    }];
    return avAsset;
}

- (NSArray *)fetchAssetsFromLast {
  NSMutableArray *assets = [NSMutableArray array];
  for (NSInteger i = 1; i <= 30; i++) {
    // Setze das Start- und Enddatum für die Suche
    NSDate *startDate = [[NSCalendar currentCalendar] dateByAddingUnit:NSCalendarUnitYear value:-i toDate:[NSDate date] options:0];
    // Setze das Startdatum auf 1 Uhr
    startDate = [[NSCalendar currentCalendar] dateBySettingHour:0 minute:0 second:0 ofDate:startDate options:0];
    // Erstelle ein Datum für das Ende des Tages heute vor 1 Jahr
    NSDate *endDate = [[NSCalendar currentCalendar] dateBySettingHour:23 minute:59 second:59 ofDate:startDate options:0];

    // Erstelle eine Optionen-Instanz mit dem Start- und Enddatum
    PHFetchOptions *options = [[PHFetchOptions alloc] init];
    options.predicate = [NSPredicate predicateWithFormat:@"creationDate > %@ AND creationDate < %@", startDate, endDate];

    // Führe die Suche durch
    PHFetchResult *result = [PHAsset fetchAssetsWithOptions:options];

    // Füge das Ergebnis der Rückgabe-Array hinzu
    [assets addObjectsFromArray:result];
  }
  return [assets copy];
}

#End If